"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var queue = require("../lib/simqle");
var Rx = require("rxjs");
var Winston = require("winston");
// import { Promise } from 'es6-shim';
// import { Promise } from 'es6-shim';
// const logger = new Rx.Subject<queue.LogMsg>();
var winstonLogger = new Winston.Logger({
    level: 'info',
    transports: [
        new (Winston.transports.Console)()
    ]
});
function logger(l) {
    var awin = winstonLogger;
    awin[l.level].apply(awin[l.level], l.parts);
}
function counter(oneState) {
    return {
        next: function (a) {
            // console.log('one.Next:', a, oneState.next);
            oneState.next += a;
        },
        error: function (err) {
            oneState.error++;
            // console.log('one.Error:', err);
        },
        complete: function () {
            oneState.complete++;
            // console.log('one.Completed:');
        }
    };
}
function worker(ms, ofs, cb) {
    return function (input, output) {
        // console.log('Worker:Started');
        var nrs = [];
        input.subscribe(function (nr) {
            // console.log('worker:', nr);
            nrs.push(nr);
        }, function (err) {
            output.error(err);
        }, function () {
            setTimeout(function () {
                nrs.forEach(function (nr) { return output.next(nr + ofs); });
                output.complete();
                cb();
            }, ms);
        });
    };
}
function qLoop(q, loops, countDownLedge) {
    return new Promise(function (rs, rj) {
        var oneState = { next: 0, error: 0, complete: 0 };
        var one = counter(oneState);
        countDownLedge.subscribe(function (a) {
            try {
                if (a == loops) {
                    chai_1.assert.equal(oneState.next, ((loops * (loops + 1)) / 2));
                    chai_1.assert.equal(oneState.error, 0);
                    chai_1.assert.equal(oneState.complete, loops);
                    q.stop().subscribe(function () { rs(); });
                }
            }
            catch (e) {
                q.stop().subscribe(function () { rj(e); });
            }
        });
        var _loop_1 = function (i) {
            // console.log('simqle:', i);
            var c1000 = new Rx.Subject();
            c1000.subscribe(one);
            // console.log(`QEntry:Off:${i}`);
            q.push(Rx.Observable.create(function (obs) {
                // console.log(`QEntry:${j}`);
                obs.next(i);
                obs.complete();
            }), c1000);
        };
        for (var i = 1; i <= loops; ++i) {
            _loop_1(i);
        }
    });
}
describe('queue', function () {
    it('simple no worker', function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // simple
            return [2 /*return*/, new Promise(function (rs, rj) {
                    queue.start({ taskTimer: 50 }).subscribe(function (rsq) {
                        if (rsq instanceof queue.LogMsg) {
                            logger(rsq);
                            return;
                        }
                        var q = rsq;
                        var oneState = { next: 0, error: 0, complete: 0 };
                        q.length().subscribe(function (a) {
                            try {
                                if (a == 3) {
                                    chai_1.assert.equal(a, 3);
                                    chai_1.assert.equal(oneState.next, 0);
                                    chai_1.assert.equal(oneState.error, 0);
                                    chai_1.assert.equal(oneState.complete, 0);
                                    q.stop().subscribe(function () { rs(); });
                                }
                            }
                            catch (e) {
                                q.stop().subscribe(function () { rj(e); });
                            }
                        });
                        var one = counter(oneState);
                        var c1000 = new Rx.Subject();
                        c1000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            obs.next(1000);
                            obs.complete();
                        }), c1000);
                        var c2000 = new Rx.Subject();
                        c2000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            obs.next(2000);
                            obs.complete();
                        }), c2000);
                        var c3000 = new Rx.Subject();
                        c3000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            obs.next(3000);
                            obs.complete();
                        }), c3000);
                    });
                })];
        });
    }); });
    it('simple one worker', function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // simple
            return [2 /*return*/, new Promise(function (rs, rj) {
                    queue.start({ taskTimer: 50 }).subscribe(function (rsq) {
                        if (rsq instanceof queue.LogMsg) {
                            logger(rsq);
                            return;
                        }
                        var q = rsq;
                        // console.log(q);
                        var countDown = 0;
                        var countDownLedge = new Rx.Subject();
                        q.addWorker(worker(0, 2, function () { return countDownLedge.next(++countDown); }));
                        var oneState = { next: 0, error: 0, complete: 0 };
                        var one = counter(oneState);
                        countDownLedge.subscribe(function (a) {
                            try {
                                // console.log('Wait:', a);
                                if (a == 3) {
                                    chai_1.assert.equal(oneState.next, 6006);
                                    chai_1.assert.equal(oneState.error, 0);
                                    chai_1.assert.equal(oneState.complete, 3);
                                    q.stop().subscribe(function () { rs(); });
                                }
                            }
                            catch (e) {
                                q.stop().subscribe(function () { rj(e); });
                            }
                        });
                        var c1000 = new Rx.Subject();
                        c1000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:1000');
                            obs.next(1000);
                            obs.complete();
                        }), c1000);
                        var c2000 = new Rx.Subject();
                        c2000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:2000');
                            obs.next(2000);
                            obs.complete();
                        }), c2000);
                        var c3000 = new Rx.Subject();
                        c3000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:3000');
                            obs.next(3000);
                            obs.complete();
                        }), c3000);
                    });
                })];
        });
    }); });
    it('1000 one worker', function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // this.timeout(10000);
                // simple
                return [2 /*return*/, new Promise(function (rs, rj) {
                        queue.start({ taskTimer: 50 }).subscribe(function (rsq) {
                            if (rsq instanceof queue.LogMsg) {
                                logger(rsq);
                                return;
                            }
                            var q = rsq;
                            var countDown = 0;
                            var countDownLedge = new Rx.Subject();
                            q.addWorker(worker(0, 0, function () { return countDownLedge.next(++countDown); }));
                            qLoop(q, 1000, countDownLedge).then(rs).catch(rj);
                        });
                    })];
            });
        });
    });
    it('simple two worker', function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (rs, rj) {
                    var workers = [0, 0];
                    queue.start({ taskTimer: 50 }).subscribe(function (rsq) {
                        if (rsq instanceof queue.LogMsg) {
                            logger(rsq);
                            return;
                        }
                        var q = rsq;
                        var countDown = 0;
                        var countDownLedge = new Rx.Subject();
                        q.addWorker(worker(10, 2, function () { workers[0]++; countDownLedge.next(++countDown); }));
                        q.addWorker(worker(15, 2, function () { workers[1]++; countDownLedge.next(++countDown); }));
                        var oneState = { next: 0, error: 0, complete: 0 };
                        var one = counter(oneState);
                        countDownLedge.subscribe(function (a) {
                            try {
                                // console.log('Wait:', a);
                                if (a == 3) {
                                    chai_1.assert.equal(workers[0], 2, "fast worker count " + workers);
                                    chai_1.assert.equal(workers[1], 1, 'slow worker count');
                                    chai_1.assert.equal(oneState.next, 6006);
                                    chai_1.assert.equal(oneState.error, 0);
                                    chai_1.assert.equal(oneState.complete, 3);
                                    q.stop().subscribe(function () { rs(); });
                                }
                            }
                            catch (e) {
                                q.stop().subscribe(function () { rj(); });
                            }
                        });
                        var c1000 = new Rx.Subject();
                        c1000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:1000');
                            obs.next(1000);
                            obs.complete();
                        }), c1000);
                        var c2000 = new Rx.Subject();
                        c2000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:2000');
                            obs.next(2000);
                            obs.complete();
                        }), c2000);
                        var c3000 = new Rx.Subject();
                        c3000.subscribe(one);
                        q.push(Rx.Observable.create(function (obs) {
                            // console.log('QEntry:3000');
                            obs.next(3000);
                            obs.complete();
                        }), c3000);
                    });
                })];
        });
    }); });
    it('1000 three worker', function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // this.timeout(10000);
                // simple
                return [2 /*return*/, new Promise(function (rs, rj) {
                        queue.start({ taskTimer: 50 }).subscribe(function (rsq) {
                            if (rsq instanceof queue.LogMsg) {
                                logger(rsq);
                                return;
                            }
                            var q = rsq;
                            var countDown = 0;
                            var countDownLedge = new Rx.Subject();
                            q.addWorker(worker(0, 0, function () { return countDownLedge.next(++countDown); }));
                            q.addWorker(worker(0, 0, function () { return countDownLedge.next(++countDown); }));
                            q.addWorker(worker(0, 0, function () { return countDownLedge.next(++countDown); }));
                            qLoop(q, 1000, countDownLedge).then(rs).catch(rj);
                        });
                    })];
            });
        });
    });
    /*
      let calls = 10;
      let pulls = 10;
      let pidx = 0;
      q.q.subscribe(data => {
        // console.log('task: idx:pulls', pulls);
        --pulls;
        data.task.subscribe(idx => {
          // console.log('task: idx', idx, pidx);
          assert.equal(idx, pidx++, '-1-');
        }, err => {
          // console.log('task: idx: error', err);
        }, () => {
          // console.log('task: idx: complete');
        });
      });
      (Array(calls).fill(0)).forEach((_: any, idx: number) => {
        // console.log('simple:', idx);
        // const id = Math.random();
        --calls;
        q.push(Rx.Observable.create((obs: Rx.Observer<number>) => {
          // console.log('task: vals', id, calls, idx);
          obs.next(idx);
          obs.complete();
        }));
      });
      setTimeout(() => {
        assert.equal(0, pulls, 'pulls');
        assert.equal(0, calls, 'calls');
        q.stop().subscribe(() => { done(); });
      }, 800);
    });
  
    it('retries', (done) => {
      // simple 2 retries than ok with measure retryWaittime
      const q = queue.start<number>(logger, {
        reclaimTimeout: 100,
        retryWaitTime: 50,
        maxExecuteCnt: 5,
        taskTimer: 10
      });
      const idxTimer = new Map<number, number[]>();
      let calls = 10;
      const retrys = 2;
      (Array(calls).fill(0)).forEach((_: any, idx: number) => {
        // console.log('simple:', idx);
        idxTimer.set(idx, []);
        let cnt = 0;
        q.push(Rx.Observable.create((obs: Rx.Observer<number>) => {
          idxTimer.get(idx).push((new Date()).getTime());
          if (cnt++ < retrys) {
            obs.error(idx);
          } else {
            obs.next(idx);
            obs.complete();
          }
        }));
      });
      let deadLetters = 0;
      q.deadLetter.subscribe(() => { ++deadLetters; });
      setTimeout(() => {
        assert.equal(0, deadLetters, 'calls != deadletter');
        idxTimer.forEach((v, k) => {
          assert.equal(retrys + 1, v.length);
          const diff = v.map((x, i, vas) => {
            if (i < 1) { return 0; }
            return x - vas[i - 1];
          }).slice(1);
          // console.log('diff:', diff, v);
          diff.forEach((d) => {
            assert.isTrue(q.retryWaitTime <= d && d <= (q.retryWaitTime * 1.5));
          });
        });
        // assert.equal(0, calls);
        q.stop().subscribe(done);
      }, 400);
    });
  
    it('reclaim', (done) => {
      // simple 2 retries than ok with measure retryWaittime
      const q = queue.start<number>(logger, {
        reclaimTimeout: 100,
        retryWaitTime: 50,
        maxExecuteCnt: 5,
        taskTimer: 10
      });
      const idxTimer = new Map<number, number[]>();
      let calls = 10;
      const retrys = 2;
      (Array(calls).fill(0)).forEach((_: any, idx: number) => {
        // console.log('simple:', idx);
        idxTimer.set(idx, []);
        let cnt = 0;
        q.push(Rx.Observable.create((obs: Rx.Observer<number>) => {
          idxTimer.get(idx).push((new Date()).getTime());
          if (cnt++ >= retrys) {
            obs.next(idx);
          }
        }));
      });
      let deadLetters = 0;
      q.deadLetter.subscribe(() => { ++deadLetters; });
      setTimeout(() => {
        assert.equal(0, deadLetters, 'calls != deadletter');
        idxTimer.forEach((v, k) => {
          assert.equal(retrys + 1, v.length);
          const diff = v.map((x, i, vas) => {
            if (i < 1) { return 0; }
            return x - vas[i - 1];
          }).slice(1);
          // console.log('diff:', diff, v);
          diff.forEach((d) => {
            assert.isTrue(q.reclaimTimeout <= d && d <= (q.reclaimTimeout * 1.5));
          });
        });
        // assert.equal(0, calls);
        q.stop().subscribe(done);
      }, 500);
    });
  
    it('error', (done) => {
      // simple 5 error remove
      const q = queue.start<number>(logger, {
        reclaimTimeout: 100,
        retryWaitTime: 50,
        maxExecuteCnt: 5,
        taskTimer: 10
      });
      const idxTimer = new Map<number, number[]>();
      let calls = 10;
      (Array(calls).fill(0)).forEach((_: any, idx: number) => {
        // console.log('simple:', idx);
        idxTimer.set(idx, []);
        q.push(Rx.Observable.create((obs: Rx.Observer<number>) => {
          // --calls;
          idxTimer.get(idx).push((new Date()).getTime());
          obs.error(idx);
          // obs.complete();
        }));
      });
      let deadLetters = 0;
      q.deadLetter.subscribe(() => { ++deadLetters; });
      setTimeout(() => {
        assert.equal(calls, deadLetters, 'calls != deadletter');
        idxTimer.forEach((v, k) => {
          assert.equal(q.maxExecuteCnt, v.length);
          const diff = v.map((x, i, vas) => {
            if (i < 1) { return 0; }
            return x - vas[i - 1];
          }).slice(1);
          // console.log('diff:', diff, v);
          diff.forEach((d) => {
            assert.isTrue(q.retryWaitTime <= d && d <= (q.retryWaitTime * 1.5));
          });
        });
        // assert.equal(0, calls);
        q.stop().subscribe(done);
      }, 800);
    });
    */
});
//# sourceMappingURL=simqle-test.js.map